> For the complete documentation index, see [llms.txt](https://docs.postgresql.tw/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.postgresql.tw/reference/reference-server/app-pgchecksums.md).

# pg\_checksums

### pg\_checksums

pg\_checksums — enable, disable or check data checksums in a PostgreSQL database cluster

### Synopsis

`pg_checksums` \[*`option`*...] \[\[ `-D` | `--pgdata` ]*`datadir`*]

### Description

pg\_checksums checks, enables or disables data checksums in a PostgreSQL cluster. The server must be shut down cleanly before running pg\_checksums. When verifying checksums, the exit status is zero if there are no checksum errors, and nonzero if at least one checksum failure is detected. When enabling or disabling checksums, the exit status is nonzero if the operation failed.

When verifying checksums, every file in the cluster is scanned. When enabling checksums, each relation file block with a changed checksum is rewritten in-place. Disabling checksums only updates the file `pg_control`.

### Options

The following command-line options are available:

`-D directory`\
`--pgdata=directory` : Specifies the directory where the database cluster is stored.

`-c`\
`--check` : Checks checksums. This is the default mode if nothing else is specified.

`-d`\
`--disable` : Disables checksums.

`-e`\
`--enable` : Enables checksums.

`-f filenode`\
`--filenode=filenode` : Only validate checksums in the relation with filenode *`filenode`*.

`-N`\
`--no-sync` : By default, `pg_checksums` will wait for all files to be written safely to disk. This option causes `pg_checksums` to return without waiting, which is faster, but means that a subsequent operating system crash can leave the updated data directory corrupt. Generally, this option is useful for testing but should not be used on a production installation. This option has no effect when using `--check`.

`-P`\
`--progress` : Enable progress reporting. Turning this on will deliver a progress report while checking or enabling checksums.

`--sync-method=method` : When set to `fsync`, which is the default, `pg_checksums` will recursively open and synchronize all files in the data directory. The search for files will follow symbolic links for the WAL directory and each configured tablespace.

```
On Linux, `syncfs` may be used instead to ask the
operating system to synchronize the whole file systems that contain the
data directory, the WAL files, and each tablespace. See
[recovery_init_sync_method](../../server-administration/runtime-config/runtime-config-error-handling.md#GUC-RECOVERY-INIT-SYNC-METHOD) for information about
the caveats to be aware of when using `syncfs`.

This option has no effect when `--no-sync` is used.
```

`-v`\
`--verbose` : Enable verbose output. Lists all checked files.

`-V`\
`--version` : Print the pg\_checksums version and exit.

`-?`\
`--help` : Show help about pg\_checksums command line arguments, and exit.

### Environment

`PGDATA` : Specifies the directory where the database cluster is stored; can be overridden using the `-D` option.

`PG_COLOR` : Specifies whether to use color in diagnostic messages. Possible values are `always`, `auto` and `never`.

### Notes

Enabling checksums in a large cluster can potentially take a long time. During this operation, the cluster or other programs that write to the data directory must not be started or else data loss may occur.

When using a replication setup with tools which perform direct copies of relation file blocks (for example [pg\_rewind](/reference/reference-server/app-pgrewind.md)), enabling or disabling checksums can lead to page corruptions in the shape of incorrect checksums if the operation is not done consistently across all nodes. When enabling or disabling checksums in a replication setup, it is thus recommended to stop all the clusters before switching them all consistently. Destroying all standbys, performing the operation on the primary and finally recreating the standbys from scratch is also safe.

If pg\_checksums is aborted or killed while enabling or disabling checksums, the cluster's data checksum configuration remains unchanged, and pg\_checksums can be re-run to perform the same operation.

***

原文：[PostgreSQL 18.6 Documentation](https://www.postgresql.org/docs/18/app-pgchecksums.html)（英文原文，待翻譯）


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.postgresql.tw/reference/reference-server/app-pgchecksums.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
